( function(){
function dialogShow(){ //initialize dialog value with pre-existing citations & footnotes
this.currentNote = false;
var editor = this.getParentEditor(),
sel = editor.getSelection();
this.currentNote = sel.getSelectedElement(); //currently selected element. 
if(this.currentNote && this.currentNote.hasClass('supNote'))
this.setupContent(this.currentNote);
this.previewNote = editor.document.createElement('input'); 
};

function dialogOK(){ //after pressing OK, update
var editor = this.getParentEditor();
if($('input[name=usedRadio]:radio:checked').length>0){ //if current note is re-used
var val = $('input[name=usedRadio]:radio:checked').val();
var source = new CKEDITOR.dom.element($('.supNote[supKey='+val+']',editor.document.getBody().$).get(0));
elem=source.clone();
editor.insertElement(elem);
this.currentNote = elem;
}else{
if(!this.currentNote){ //new note is added
elem = editor.document.createElement('input'); //set inital values for the input.supNote element
elem.setAttribute('value','1');
elem.setStyle('width','8px');
elem.setAttribute('readonly','true');
elem.setAttribute('type','text');
elem.setAttribute('supType',this.getName());
elem.setAttribute('supKey',Math.floor(Math.random()*10000000));
elem.addClass('supNote');
editor.insertElement(elem);
this.currentNote = elem;
}
this.commitContent(this.currentNote); //execute commit functions for relevant dialogs/inputs
}
this.currentNote.on('DOMNodeRemoved',editor.notesUpdate);
editor.refreshNote();
}
function getCalendarDate() //get current date in english format
{
var months = new Array("January","February","March","April","May","June","July","August","September","October","November","December");
var now = new Date();
var monthnumber = now.getMonth();
var monthname = months[monthnumber];
var monthday = now.getDate();
var year = now.getFullYear();
var dateString = monthday+' '+monthname +' '+year;
return dateString;
}

var used = { //used tab page allow users to add a pre-existing citation/footnote again 
//this tab page is used by both citation & footnote elements
id: 'used',
label: 'Used',
title: 'Used',
accessKey: 'U',
elements:[{
type:'html',
html:'<div id="used" style="overflow-y:scroll;width:100%;background:white;height:200px;width:340px"></div>',
onShow: function()
{
//jQuery Here! Sometimes it is a good choice to use jQuery functions instead of CKEditor APIs.
$('#used').html('');
usedlist= this.getDialog().getParentEditor().genUsedList(this.getDialog().getName(),false);
for( var key in usedlist)
$('#used').append('<table style="width:100%;border-bottom:1px solid #CCCCCC;"><tr><td style="width:20px;vertical-align:middle;"><input type="radio" name="usedRadio" value="'+
key+'"/></td><td style="padding:5px; white-space:normal">'+usedlist[key]+'</tr></div>');
}
}]
};
var citationFields = { //fields for different citation formats
'book':['authors', 'title','publisher','date','volume','edition','page','url','isbn'],
'paper':['authors','title','journal','volume','issue','page','publisher','date','url','doi'],
'news': ['authors', 'title', 'newspaper','date','url','accessdate'],
'website':['authors','title','publisher','date','url','accessdate']
};
var allfields = ['authors', 'title','publisher','date','volume','edition','page','url','doi','isbn','journal','issue','newspaper','accessdate'];
var footnoteDialog = function(editor){ //layout for footnote dialog
return {
title : 'Footnote',
minWidth : 300,
minHeight : 340,
onShow: dialogShow,
onOk: dialogOK,
contents: [{
id: 'footnote',
label: 'Footnote',
title: 'Footnote',
accessKey:'F',
elements:[{
type: 'textarea',
id: 'txtFootnote',
label: 'Footnote',
setup: function(element){
this.setValue(element.getAttribute('footnote'));
},
validate: function() //validate before dialog close
{
if($('input[name=usedRadio]:radio:checked').length==0 && this.getValue()==''){
alert('Please enter your footnote or choose a used footnote.');
return false; //return false: validation fails and dialog won't close
}
return true; //validation fails and dialog will close
},
commit: function(element){
element.setAttribute('footnote',this.getValue());
}
}]
},used] //used tab page goes here
}
}
var eOC = function(element){ //executed during commit
if(this.isEnabled()){ //"this" refer to the calling dialog element 
element.setAttribute(this.id,this.getValue()); //element refer to the supNote input element
}else{
if(element.hasAttribute(this.id))
element.removeAttribute(this.id)
}
}
var eOS = function(element){ //executed during setup
if(element.hasAttribute(this.id))
this.setValue(element.getAttribute(this.id))
}
var onC = function(){ //executed during onChange
if(this.getDialog().previewNote){ 
this.getDialog().commitContent(this.getDialog().previewNote);
$('#citationpreview').html(this.getDialog().getParentEditor().formatSup(this.getDialog().previewNote));
}
}
var citationDialog = function(editor){ //citation dialog layout
return {
title: 'Citation',
minWidth: 340,
minHeight : 340,
onShow: dialogShow,
onOk: dialogOK,
contents:[{
id:'citation',
label: 'Citation',
title: 'Citation',
accessKey: 'C',
elements:[{
type: 'select',
id: 'citationType',
label: 'Citation Media Type',
labelLayout:'horizontal',
items:[
["Book","book"],
['Website','website'],
["Journal/Paper/Thesis/Dissertation", 'paper'],
['News Article', 'news'],
],

commit:eOC,
setup:eOS,
onChange: function(){ //when dialog fields change, update the citation format preview
for(var i=0;i<allfields.length;i++){ 
//enable input fields according to different citation formats
//and hide fields that are not used for a particular citation format
var fields=citationFields[this.getValue()];
var enable=false;
var currField = this.getDialog().getContentElement('citation',allfields[i]);
for(var j=0;j<fields.length;j++){
if(fields[j]==allfields[i]){
currField.enable();
currField.getElement().show();
currField.getElement().getParent().setStyle('padding','5px 0');
enable=true;
break;
}
}
if(!enable){
currField.disable();
currField.getElement().hide();
currField.getElement().getParent().setStyle('padding','0px');
}
}
if(this.getDialog().previewNote){
// console.log(this.getDialog().previewNote);
this.getDialog().previewNote.setAttribute(this.id,this.getValue());
$('#citationpreview').html(this.getDialog().getParentEditor().formatSup(this.getDialog().previewNote));
}
}
},{
type: 'text',
id: 'authors',
label: 'Authors',
commit:eOC,
setup:eOS,
onChange:onC
},{
type: 'text',
id: 'title',
label: 'Title',
commit:eOC,
setup:eOS,
onChange:onC
},{
type: 'text',
id: 'url',
label: 'URL',
commit:eOC,
setup:eOS,
onChange:onC
},{
type: 'text',
id: 'journal',
label: 'Journal',
commit:eOC,
setup:eOS,
onChange:onC
},{
type: 'text',
id: 'publisher',
label: 'Publisher',
commit:eOC,
setup:eOS,
onChange:onC
},{
type:'text',
id:'newspaper',
label:'Newspaper',
commit:eOC,
setup:eOS,
onChange:onC
},{
type: 'text',
id:'date',
label: 'Publication Date or Year',
commit:eOC,
setup:eOS,
onChange:onC
},{
type: 'text',
id: 'volume',
label: 'Volume',
commit:eOC,
setup:eOS,
onChange:onC
},{
type:'text',
id:'issue',
label: 'Issue',
commit:eOC,
setup:eOS,
onChange:onC
},{
type: 'text',
id:'edition',
label: 'Edition',
commit:eOC,
setup:eOS,
onChange:onC
},{
type: 'text',
id:'page',
label: 'Page Number',
commit:eOC,
setup:eOS,
onChange:onC
},{
type: 'text',
id:'doi',
label: 'doi',
commit:eOC,
setup:eOS,
onChange:onC
},{
type: 'text',
id: 'isbn',
label: 'ISBN',
commit:eOC,
setup:eOS,
onChange:onC
},{
type:'text',
id:'accessdate',
label:'Access Date',
commit:eOC,
setup:eOS,
onChange:onC,
onShow:function(){
if(this.getValue()=='')
this.setValue(getCalendarDate());
}
},{
type:'html',
html:'Citation Preview:<br/><div id="citationpreview" style="text-decoration:normal;font-weight:normal;font-style:normal;white-space:normal;width:328px;background-color:white;border:1px solid #000000;padding:5px"></div>',
}]
},used]
}
}


CKEDITOR.dialog.add('footnote', function(editor) {
return footnoteDialog(editor);
});
CKEDITOR.dialog.add('citation', function(editor){
return citationDialog(editor);
});

editor.ui.addButton('Footnote', //toolbat button for footnote
            {
                label: 'Footnote',
                command: pluginName,
                icon : this.path + 'icon1.gif'
            });

})();