CKEDITOR.plugins.add('footnote',
{
init: function(editor)
{
editor.notesUpdate = function(){
setTimeout(editor.refreshNote , 0);
}
editor.refreshNote = function(){
var dupSup = {};
var count=0;
var allsup = editor.document.getElementsByTag('input'); //get all the input elements
for(var i=0;i<allsup.count();i++){
var sup = allsup.getItem(i);
if(sup.hasClass('supNote')){ 
//if the input element is a footnote/citation, update the current footnote numbers 
//so that there's no gap in the numbers
//for example, when footnote 2 is deleted, then footnote 3 become footnote 2
if(sup.getAttribute('supKey') in dupSup){ 
sup.setAttribute('value',dupSup[sup.getAttribute('supKey')]);
}else{
count++;
var strcount=count+'';
sup.setAttribute('value',strcount);
sup.setStyle('width',strcount.length*8+'px');
dupSup[sup.getAttribute('supKey')]=strcount;
}
}
}
editor.fire('refreshNote'); //fire refreshNote event so that external javascript can listen
};
editor.formatSup = function(element){
function a(s){
return element.getAttribute(s);
}
if(a('suptype')=='footnote')
return a('footnote');
else{ // generate the Citation HTML according to different citation types
var ct = a('citationtype');
var authors = a('authors'),
date = a('date')?(" ("+a('date')+"), "):'',
title = a('url')?("<a style='color:blue' href='"+a('url')+"'>"+a('title')+"</a>"):(a('title')?a('title'):''),
publisher = a('publisher')?a('publisher')+". ":'',
page = a('page'),
doi = a('doi')?('doi:<a style="color:blue" href="http://dx.doi.org/'+a('doi')+'">'+a('doi')+'</a>'):'',
isbn = a('isbn')?('ISBN:' +a('isbn')):'',
volume = a('volume'),
edition = a('edition')?(a('edition')+", "):'',
journal = a('journal')?("<em>"+a('journal')+"</em>"):'',
accessdate = a('accessdate')?("Retrieved "+a('accessdate')):'',
newspaper = a('newspaper')?(a('newspaper')+", "):'',
issue = a('issue');
aspace = (authors&&title&&!date)?', ':'',
arttitle=title?('"'+title+'", '):'';
var result='';
if(ct=='book'){
result = authors+aspace+date+(title?("<span style='font-style:italic'>"+title+"</span>, "):'')+
(volume?(volume+", "):'')+edition+publisher+(page?('pp.'+page+', '):'')+isbn;
}else if(ct=='paper'){
result = authors+aspace+date+ arttitle+ "<span style='font-style:italic'>"+journal+"</span>"+(a('publisher')?(' ('+a('publisher')+') '):'') + 
(volume?("<span style='font-weight:bold'>"+volume+"</span>"):'')+(issue?('('+issue+')'):'')+(page?(":"+page+', '):'')+doi+isbn;
}else if(ct=='news'){
result = authors+aspace+date+arttitle+ "<span style='font-style:italic'>"+newspaper+"</span>"+accessdate;
}else if(ct=='website'){
result = authors+aspace+date+(a('title')?arttitle:(a('url')+', '))+publisher+accessdate;
}
return result.replace(/, $/,'.');
}
};
editor.genUsedList = function(limit,value){ //generate a list of all used footnote/citation
var allsup = editor.document.getElementsByTag('input');
var results = {};
for(var i=0;i<allsup.count();i++){
var sup = allsup.getItem(i);
if(sup.hasClass('supNote')){
if(limit!='' && sup.getAttribute('supType')!=limit)
continue;
if(value){
results[sup.getAttribute('value')]=editor.formatSup(sup);
}else{
results[sup.getAttribute('supKey')]=editor.formatSup(sup);
}
}
}
return results;
};
var pluginName = 'footnote';
CKEDITOR.dialog.add(pluginName, this.path + 'dialogs/footnote.js'); 
editor.addCommand(pluginName, new CKEDITOR.dialogCommand(pluginName));
editor.ui.addButton('Footnote', //toolbar button for footnote
{
label: 'Footnote',
command: pluginName
});
CKEDITOR.dialog.add('citation',this.path+'dialogs/footnote.js');
editor.addCommand('citation', new CKEDITOR.dialogCommand('citation'));
editor.ui.addButton('Citation', //toolbar button for citation
{
label: 'Citation',
command: 'citation'
});
if(CKEDITOR.env.ie){ 
//IE have no DOMNodeRemoved event, so we refreshNote periodically to keep Citation and numbers consistent 
setInterval(editor.refreshNote , 15000);
}
if(editor.addMenuItems) //Initializing menu items for use in Context Menu
{
editor.addMenuItems(
{
footnote:
{
label: 'Footnote',
command: 'footnote',
group: 'footnote'
},
citation:{
label:'Citation',
command:'citation',
group: 'footnote'
}
});
}
if(editor.contextMenu) //if contextMenu is enabled
{
editor.contextMenu.addListener(function(element, selection) //execute following code when context menu is shown
{
if(element && element.is('input')){
if(element.getAttribute('supType')=='footnote'){
//return footnote menu item with unactivated state 
return { footnote: CKEDITOR.TRISTATE_OFF }; 
}else if(element.getAttribute('supType')=='citation')
//return citation menu item with unactivated state 
return { citation: CKEDITOR.TRISTATE_OFF };
}else
return null;
});
}
editor.on('contentDom', function() //when the pre-filled data in CKEditor is ready
{
var doc=editor.document;
var allsup = doc.getElementsByTag('input'); //select all the input elements
for (var i=0;i<allsup.count();i++){
var sup = allsup.getItem(i);
if(sup.hasClass('supNote')){ 
//if the input element is a footnote/citation, bind editor.notesUpdate to DOMNodeRemoved 
sup.on('DOMNodeRemoved', editor.notesUpdate);
}
}
});
}
});